global float camRot;
global float camX;
global float camY;
global float camZ;

public class Cam extends GGen {

    VectorMath m;

    // vec3 target;

    // for some reason flycam doesn't work so here's a custom camera

    GGen view --> this;

    GG.scene().camera() @=> GCamera @ cam;
    cam --> view;
    cam.pos(@(0,0,0));
    // cam.clip(-250, 250);

    Wand wand --> view;
    wand.pos( @(0,-1.5,-2) );
    wand.rotate( @(0,0,-Math.PI/2.0) );

    Keyboard keyboard;
    Mouse mouse;

    spork ~ mouse.selfUpdate(); // start updating mouse position

    // fun Cam(Keyboard @ k)
    // {
    //     k @=> this.keyboard;
    // }
    

    cam.clip(0.1, 1000);
    <<< cam.clipFar(), cam.clipNear() >>>;



    0.02 => float sensitivity;

    fun void updatePos() {
        while (true) {
            GG.nextFrame() => now;
            
            wand.posWorld() => vec3 camPos;
            m.normalize(camPos) => camPos;

            camPos.x => camX;
            camPos.y => camY;
            camPos.z => camZ;
        }
    } spork ~ updatePos();

    fun void updateRotation() {
        while (true) {
            GG.nextFrame() => now;
            
            this.rotY() => camRot;
            // <<< "camRot: ", camRot >>>;
        }
    } spork ~ updateRotation();

    fun void listener()
    {
        if (keyboard.look_left) {
            this.rotateY(sensitivity);
            // <<< "looking left" >>>;
        } 
        if (keyboard.look_right) {
            this.rotateY(-sensitivity);
            // <<< "looking right" >>>;
        }
        if (keyboard.look_up) {
            if (view.rotX() + sensitivity < Math.PI/2.0 && view.rotX() + sensitivity > -Math.PI/2.0) {
                view.rotateX(sensitivity);
                // <<< "looking up" >>>;
            }
        }
        if (keyboard.look_down) {
            if (view.rotX() - sensitivity < Math.PI/2.0 && view.rotX() - sensitivity > -Math.PI/2.0) {
                view.rotateX(-sensitivity);
                // <<< "looking down" >>>;
            }
        }
    }


    fun vec3 getTarget()
    {
       return wand.posWorld();
    }

    int wandIsInFront;
    float targetRotZ;
    // vec3 wandPos;
    
    fun void moveWand() {
        while (true) {
            GG.nextFrame() => now;

            if (keyboard.space) {
                0 => targetRotZ;
            } else if (keyboard.O) {
                -Math.PI / 2.0 => targetRotZ;
            } else {
                -Math.PI / 5.0 => targetRotZ;
                // @(1,0,0) => wandPos;
            }

            
            wand.rotZ() => float currentRotZ;
            0.05 => float step;


            
            if (Math.fabs(currentRotZ - targetRotZ) > step) {
                (currentRotZ < targetRotZ) ? 1 : -1 => float direction;
                wand.rotate(@(0, 0, direction * step));
            } else {
                wand.rotZ(targetRotZ);
            }


            if (Math.fabs(targetRotZ) < 0.001) { // Close enough to targetRotZ = 0
                true => wandIsInFront;
            } else {
                false => wandIsInFront;
            }
            wand.checkIfWandInFront(wandIsInFront);
        }
    } spork ~ moveWand();







    fun void update(float dt)
    {
        listener();
    }


}