public class VectorMath {

    fun float dot(vec3 a, vec3 b) {
        return a.x*b.x + a.y*b.y + a.z*b.z;
    }

    fun float norm(vec3 a) {
        return Math.sqrt(dot(a, a));
    }

    fun vec3 normalize(vec3 a) {
        return a / norm(a);
    }

    fun vec3 cross(vec3 a, vec3 b) {
        return @(a.y*b.z - a.z*b.y, a.z*b.x - a.x*b.z, a.x*b.y - a.y*b.x);
    }

    fun float sign(float a) {
        if (a > 0) {
            return 1;
        } else if (a < 0) {
            return -1;
        } else {
            return 0;
        }
    }

    fun float det(vec2 a, vec2 b) {
        return a.x*b.y - a.y*b.x;
    }

    fun float angleBetween(vec3 a, vec3 b) {
        return Math.acos(dot(a,b) / (norm(a) * norm(b)));
    }
}