global float volume;

public class Wand extends GGen {
    Texture.load(me.dir() + "textures/rusty_normal.jpeg") @=> Texture rusty_normal;

    PBRMaterial wandmat; 
    wandmat.metallic(1);
    wandmat.roughness(0.25);
    wandmat.normalMap(rusty_normal);
    wandmat.color( @(1,1,1)*7 );
    // wandmat.color( @(0,0.75,1)*7 );


    Keyboard keyboard;
    spork ~ keyboard.listener();

    0.015 => float radius;

    CylinderGeometry handleGeo(
        0.9*radius, // radiusTop
        1.1*radius, // radiusBottom
        1.0, // height
        32, // radialSegments
        1, // heightSegments
        false, // openEnded
        0, // thetaStart
        Math.PI * 2 // thetaLength
    );
    TorusGeometry jaggedGeo(
        0.02, // radius
        0.5*radius, // tube
        16, // radialSegments
        100, // tubularSegments
        2*Math.PI // arclength
    );

    GMesh handle --> this;
    GMesh hole --> this;
    50 => int numJagged;
    GMesh jagged[numJagged];

    vec3 axis;  
    
    for (0 => int i; i < numJagged; i++) {
        @(Math.cos(Math.TWO_PI*i/numJagged$float), Math.sin(Math.TWO_PI*i/numJagged$float), 0) => axis;
        jagged[i] --> hole;
        jagged[i].mesh(jaggedGeo, wandmat);
        jagged[i].rot( @( Math.PI/2.0, Math.PI/2.0, 0.5 + Math.TWO_PI*i/numJagged$float) );
        jagged[i].pos( 0.1*axis );
        jagged[i].sca( @(1,1,Math.random2f(0.9,1.1)) );
    }
    

    handle.mesh(handleGeo, wandmat);
    // hole.mesh(holeGeo, wandmat);

    handle.pos( @(0, handleGeo.height() / 2.0, 0) );
    hole.pos( @(0, handleGeo.height() + 0.1, 0) );



    fun void GenerateSmallBubble(float blowStrength) {
       
        Bubble bubble --> GG.scene();
        bubble.setInitialVelocity(this.posWorld() - @(0,4,0), 0.5 + Math.pow(blowStrength, 1/3.0));
        bubble.pos( 1.01*hole.posWorld() );
        bubble.sca( Math.random2f(0.75, 1.25) );

        bubble.detachFromWand();

        while (true) {
            GG.nextFrame() => now;
        }

    }


    fun void GenerateLargeBubble(float blowStrength) {

        Bubble bubble --> GG.scene();
        bubble.setInitialVelocity(this.posWorld() - @(0,4,0), 0.5 + Math.sqrt(blowStrength));
        bubble.pos( 1.01*hole.posWorld() );
        bubble.sca( 2 );

        bubble.detachFromWand();

        while (true) {
            GG.nextFrame() => now;
        }

    }


    int wandInFront;
    fun void checkIfWandInFront(int wif) {
        wif => wandInFront;
    }


    fun void popSound() {
        Pop pop => dac;
        spork ~ pop.play();
    }
    


    fun void blow() {
        
        //generic bubble object
        Bubble bubble[0];
        int isBubbleGrowing;
        -1 => int bubbleIndex;

        while( true )
        {
            GG.nextFrame() => now;
            
            if( wandInFront)
            {    
                if (volume > 0.1 ) {
                    if (volume > 3 && !keyboard.B ) {
                        // <<<"generating small bubbles">>>;
                        
                        // if a bubble has been growing and the blow strength passes 1, detach the bubble from the wand
                        if (isBubbleGrowing == 0.5) {
                            bubble[bubbleIndex].detachFromWand();
                            false => isBubbleGrowing;
                            // popSound();
                        }

                        // generate small bubbles
                        spork ~ GenerateSmallBubble(volume);
                        // wait for a bit until the next bubble
                        for (int i; i < 5; i++) {
                            GG.nextFrame() => now;
                        }

                    } else if (volume <= 0.5 || keyboard.B ) {
                        
                        if (isBubbleGrowing == 0) {
                            // <<<"generating a large bubble">>>;
                            Bubble newBubble --> GG.scene();
                            newBubble.setInitialVelocity(this.posWorld() - @(0, 4, 0), 0.5);
                            newBubble.pos(hole.posWorld()); // Position at the wand's hole
                            newBubble.sca(@(1,1,1)*0.5); // Initial small scale
                            bubble << newBubble;
                            true => isBubbleGrowing; // Bubble is now growing
                            bubbleIndex++;
                        } else if (isBubbleGrowing == 1) {
                            //  <<<"growing large bubble">>>;
                            bubble[bubbleIndex].sca() + 0.025*@(1,1,1) => bubble[bubbleIndex].sca; // Gradually increase scale
                            bubble[bubbleIndex].pos( 1.025*hole.posWorld() ); // Position at the wand's hole
                            bubble[bubbleIndex].pos(hole.posWorld()); // Position at the wand's hole
                        }
                    }
                } else { // if a bubble has been growing and the blow strength drops below 0.05, detach the bubble from the wand
                    if (isBubbleGrowing == 1) {
                        bubble[bubbleIndex].detachFromWand();
                        false => isBubbleGrowing;
                    }
                }
            }
            
        }
    } spork ~ blow();

}







